src/Entity/Task.php
<?php

namespace App\Entity;

use Gedmo\Slug;
use Carbon\Carbon;
use Gedmo\Sluggable\Sluggable;
use Doctrine\ORM\Mapping as ORM;
use App\Repository\TaskRepository;
use Gedmo\Mapping\Annotation as Gedmo;
use Symfony\Component\Validator\Constraints as Assert;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;

/**
 * @ORM\Entity(repositoryClass=TaskRepository::class)
 * @UniqueEntity("title")
 * @ORM\HasLifecycleCallbacks
 * @Gedmo\SoftDeleteable(fieldName="deleted_at")
 */
class Task
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $title;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     * @Gedmo\Slug(fields={"title"})
     */
    private $slug;

    /**
     * @ORM\Column(type="text")
     */
    private $description;

    /**
     * @ORM\ManyToOne(targetEntity=User::class, inversedBy="tasks", fetch="EXTRA_LAZY")
     * @ORM\JoinColumn(nullable=false)
     * @ORM\OrderBy({"created_at"="DESC"})
     */
    private $created_by;

    /**
     * @ORM\ManyToOne(targetEntity=User::class, inversedBy="tasks", fetch="EXTRA_LAZY")
     * @ORM\JoinColumn(nullable=false)
     * @ORM\OrderBy({"created_at"="DESC"})
     */
    private $assigned_to;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $priority;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $status = "pending";

    /**
     * @ORM\Column(type="datetime", nullable=true)
     * @Gedmo\Timestampable(on="create")
     */
    private $created_at;

    /**
     * @ORM\Column(type="datetime", nullable=true)
     * @Gedmo\Timestampable(on="update")
     */
    private $updated_at;

    /**
     * @ORM\Column(name="deleted_at", type="datetime", nullable=true)
     */
    private $deleted_at;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getTitle(): ?string
    {
        return $this->title;
    }

    public function setTitle(string $title): self
    {
        $this->title = $title;

        return $this;
    }

    public function getSlug(): ?string
    {
        return $this->slug;
    }

    public function setSlug(?string $slug): self
    {
        $this->slug = $slug;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(string $description): self
    {
        $this->description = $description;

        return $this;
    }

    public function getCreatedBy(): ?User
    {
        return $this->created_by;
    }

    public function setCreatedBy(?User $created_by): self
    {
        $this->created_by = $created_by;

        return $this;
    }

    public function getAssignedTo(): ?User
    {
        return $this->assigned_to;
    }

    public function setAssignedTo(?User $assigned_to): self
    {
        $this->assigned_to = $assigned_to;

        return $this;
    }

    public function getPriority(): ?string
    {
        return $this->priority;
    }

    public function setPriority(string $priority): self
    {
        $this->priority = $priority;

        return $this;
    }

    public function getStatus(): ?string
    {
        return $this->status;
    }

    public function setStatus(?string $status): self
    {
        $this->status = $status;

        return $this;
    }

    public function getCreatedAt(): ?string
    {
        return Carbon::parse($this->created_at)->diffForHumans();
    }

    public function getUpdatedAt(): ?string
    {
        return Carbon::parse($this->updated_at)->diffForHumans();
    }

    public function getDeletedAt(): ?\DateTimeInterface
    {
        return $this->deleted_at;
    }

    public function setDeletedAt(?\DateTimeInterface $deleted_at): self
    {
        $this->deleted_at = $deleted_at;

        return $this;
    }
}

src/Form/TaskType.php
<?php

namespace App\Form;

use App\Entity\Task;
use App\Entity\User;
use Doctrine\ORM\EntityRepository;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\SubmitType;
use Symfony\Component\Form\Extension\Core\Type\TextareaType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Security\Core\Security;

class TaskType extends AbstractType
{
    public function __construct(private Security $security){}

    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('title', TextType::class, [
                "attr" => [
                    "placeholder" => "Insert a title"
                ]
            ])
            ->add('description', TextareaType::class, [
                "attr" => [
                    "placeholder" => "Insert a description"
                ]
            ])
            ->add('priority', ChoiceType::class, [
                "choices" => [
                    "Feature" => "feature",
                    "Bug fix"=> "bug",
                    "Urgent" => "urgent"
                ]
            ])
            ->add('assigned_to', EntityType::class, [
                "class" => User::class,
                "query_builder" => function(EntityRepository $em){
                    return $em->createQueryBuilder('u')
                        ->where('u.id != :id')
                        ->setParameter('id', $this->security->getUser()->getId())
                        ->orderBy('u.id', 'ASC')
                    ;
                }
            ])
            ->add("Save", SubmitType::class, [
                "attr" => [
                    "class" => "btn btn-success"
                ]
            ])
        ;
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => Task::class,
        ]);
    }
}

src/Controller/TaskController.php
<?php

namespace App\Controller;

use App\Entity\Task;
use App\Form\TaskType;
use Doctrine\ORM\EntityManagerInterface;
use Knp\Component\Pager\PaginatorInterface;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;

/**
 * @Route("app", name="app_")
 */
class TaskController extends AbstractController
{

    /**
     * @Route("/tasks", name="task_index", methods={"GET"})
     * @return Response
     */
    public function index (Request $request,PaginatorInterface $paginator, EntityManagerInterface $em): Response
    {
        //$user_id = $this->getUser()->getId();

        $user = $this->getUser();

        $q = $request->query->get('q');

        $permission = $this->isGranted('ROLE_ADMIN');

        $query = $em->getRepository(Task::class)
            ->findByUserRole( $user, $q, $permission );
        /*
        if ( $this->isGranted('ROLE_ADMIN') ) {
    
            $query = $em->getRepository(Task::class)
                ->findByUserRole($user_id,$q, $this->isGranted('ROLE_ADMIN'));
        
        } elseif( $this->isGranted("ROLE_SUPER_ADMIN") ) {



        } else {

            $query = $em->getRepository(Task::class)
                ->createQueryBuilder('t')
                ->andWhere('t.assigned_to = :id')
                ->setParameter('id', $user_id)
                ->orderBy("t.id", "DESC")
                ->getQuery();

        }
        */

        $tasks = $paginator->paginate(
            $query,
            $request->query->getInt('page',1),
            5
        );

        //dd($tasks);

        return $this->render("./pages/task/index.html.twig", compact("tasks"));

    }

    /**
     * @Route("/tasks/create", name="task_create", methods={"GET","POST"})
     */
    public function create (Request $request)
    {
        $task = new Task();

        if ( !$this->isGranted('TASK_CREATE', $task) ) {

            $this->addFlash("error", "Sorry but you don't have permission to access this page.");

            return $this->redirectToRoute("app_task_index");

        }

        $form = $this->createForm(TaskType::class, $task, [
            "method" => "POST",
            "action" => $this->generateUrl("app_task_create")
        ]);

        $form->handleRequest($request);

        if ( $form->isSubmitted() and $form->isValid() ) {

            $task->setCreatedBy($this->getUser());

            $d = $this->getDoctrine();

            $em = $d->getManager();

            $em->persist($task);

            $em->flush();

            $this->addFlash("success","The task is created successfully !!");

            return $this->redirectToRoute("app_task_create");

        }

        return $this->render("./pages/task/create.html.twig", [
            "task_form" => $form->createView()
        ]);

    }

    /**
     * @Route("/tasks/{slug}", name="task_show", methods={"GET"})
     * @return Response
     */
    public function show (string $slug, EntityManagerInterface $em)
    {

        $task = $em->getRepository(Task::class)->findOneBy([
            "slug" => $slug
        ]);

        if ( !$this->isGranted('TASK_VIEW', $task) ) {

            $this->addFlash("error", "Sorry but you don't have permission to access this page.");

            return $this->redirectToRoute("app_task_index");

        }

        return $this->render("./pages/task/show.html.twig", compact("task"));

    }

    /**
     * @Route("/tasks/{id}/edit", name="task_edit", methods={"GET","PUT"})
     * @return Response
     */
    public function edit (string $id, Request $request, EntityManagerInterface $em): Response
    {
        $task = $em->getRepository(Task::class)->findOneBy([
            "id" => $id
        ]);

        if ( !$this->isGranted('TASK_EDIT', $task) ) {

            $this->addFlash("error", "Sorry but you don't have permission to access this page.");

            return $this->redirectToRoute("app_task_index");

        }

        $form = $this->createForm(TaskType::class, $task, [
            "method" => "PUT",
            "action" => $this->generateUrl("app_task_edit", [
                "id" => $task->getId()
            ])
        ]);

        $form->handleRequest($request);

        if ( $form->isSubmitted() and $form->isValid() ) {

            $task->setCreatedBy($this->getUser());

            $d = $this->getDoctrine();

            $em = $d->getManager();

            $em->persist($task);

            $em->flush();

            $this->addFlash("success","The task is updated successfully !!");

            return $this->redirectToRoute("app_task_edit", [
                "id" => $task->getId()
            ]);

        }

        return $this->render("./pages/task/edit.html.twig", [
            "task_form" => $form->createView()
        ]);


    }

    /**
     * @Route("/tasks/{id}", name="task_destroy", methods={"DELETE"})
     * return Response
     */
    public function destroy (string $id, Request $request, EntityManagerInterface $em): Response
    {   
        $token = $request->request->get('_token');

        $task = $em->getRepository(Task::class)->findOneBy([
            "id" => $id
        ]);

        if ( !$this->isGranted('TASK_DELETE', $task) ) {

            $this->addFlash("error", "Sorry but you don't have permission to run this action.");

            return $this->redirectToRoute("app_task_index");

        }
       
        if ( $this->isCsrfTokenValid("task_delete_".$task->getId(),$token) ) {

            $em->remove($task);

            $em->flush();

            $this->addFlash("success", "The task is deleted succuessfully !!");
        
        }

        return $this->redirectToRoute("app_task_index");
    }
}

templates/pages/task/create.html.twig
{% extends './layouts/app.html.twig' %}

{% block title "Create task" %}

{% block content %}

    <div>

        <a class="btn btn-primary float-right" href="{{ path('app_task_index') }}">Back to the list of tasks</a>

        <h1>Create New Task</h1>

    </div>

    {{ form_start(task_form) }}
    {{ form_end(task_form) }}

{% endblock %}

templates/pages/task/edit.html.twig
{% extends './layouts/app.html.twig' %}

{% block title "Edit task" %}

{% block content %}

    <div>

        <a class="btn btn-primary float-right" href="{{ path('app_task_index') }}">Back to the list of tasks</a>

        <h1>Edit The Task</h1>

    </div>

    {{ form_start(task_form) }}
    {{ form_end(task_form) }}

{% endblock %}

templates/pages/task/index.html.twig
{% extends './layouts/app.html.twig' %}

{% block title "Tasks" %}

{% block content %}
    <div>
        {% if is_granted("ROLE_ADMIN") %}
            <a class="btn btn-success mb-3 float-right" href="{{ path('app_task_create') }}">Create new task</a>
        {% endif %}
        <h1>Tasks({{ tasks.getTotalItemCount }})</h1>
        <form>
            <div class="input-group mb-3">
                <input 
                    type="text" 
                    class="form-control" 
                    value="{{ app.request.query.get('q') }}"
                    placeholder="Search for specific tasks" 
                    name="q"
                />
                <button class="btn btn-primary" type="submit">Search</button>
            </div>
        </form>

    </div>

    <table class="table table-hover table-stripped table-bordered">
    
        <thead>

            <tr>
                <th>Title</th>
                {% if is_granted('ROLE_ADMIN') %}
                    <th>Assigned to</th>
                {% endif %}
                <th>Priority</th>
                <th>Status</th>
                <th>Created at</th>
                <th>Actions</th>
            </tr>
        
        </thead>

        <tbody>
            {% for item in tasks %}
                <tr>
                    <td>{{ item.title }}</td>
                    {% if is_granted('ROLE_ADMIN') %}
                        <td>{{ item.assignedTo.name }}</td>
                    {% endif %}
                    <td>{{ item.priority }}</td>
                    <td>{{ item.status }}</td>
                    <td>{{ item.createdAt | date('Y-m-d H:i') }}</td>
                    <td class="d-flex">
                        {% if is_granted('TASK_VIEW', item) %}
                            <a class="btn btn-info btn-sm mr-1" href="{{ path('app_task_show', { slug: item.slug }) }}">Show</a>
                        {% endif %}
                        {% if is_granted('TASK_EDIT', item) %}
                            <a class="btn btn-warning mr-1 btn-sm" href="{{ path('app_task_edit', { id: item.id }) }}">Edit</a>
                        {% endif %}
                        {% if is_granted("TASK_DELETE", item) %}
                            <form method="POST" action=" {{ path('app_task_destroy',{ id: item.id }) }}">
                                <input type="hidden" name="_method" value="DELETE" />
                                <input type="hidden" name="_token" value="{{ csrf_token('task_delete_'~item.id) }}" />
                                <button class="btn btn-danger btn-sm mr-1" type="submit">Delete</button>
                            </form>
                        {% endif %}
                        {% if is_granted('ROLE_ADMIN') %}
                            {% if item.status == 'finished' %}
                                <a class="btn btn-light btn-sm mr-1" href="#">completed</a>
                            {% endif %}
                        {% else %}
                            {% if item.status == 'pending' %}
                                <a class="btn btn-dark btn-sm mr-1" href="#">Start working</a>
                            {% endif %}
                            {% if item.status == 'working' %}
                                <a class="btn btn-success btn-sm mr-1" href="#">Finished</a>
                            {% endif %}
                        {% endif %}
                    </td>
                </tr>
            {% else %}
                <tr>
                    <td colspan="{% if is_granted('ROLE_ADMIN') %}6{% else %}5{% endif %}">
                        <div class="alert alert-danger m-0">

                            {% if app.request.query.get('q') %}
                                
                                There are not tasks with the name <b>"{{ app.request.query.get('q') }}"</b>
                            
                            {% elseif is_granted('ROLE_ADMIN') %}
                            
                                There are no tasks yet, please creare some.
                            
                            {% else %}

                                There are not tasks assigned to you, please wait until the admin assign some tasks for you.
                            
                            {% endif %}

                        </div>
                    </td>
                </tr>
            {% endfor %}
        </tbody>

    </table>

    <div class="navigation">
        {{ knp_pagination_render(tasks) }}
    </div>

{% endblock %}

templates/pages/task/show.html.twig
{% extends './layouts/app.html.twig' %}

{% block title "Detail task" %}

{% block content %}
    
    <div class="card">
        <div class="card-header">
            <a class="btn btn-primary btn-sm float-right" href="{{ path('app_task_index') }}">Back to list</a>
            <span>Detail task</span>
        </div>
        <div class="card-body">
            <h1>{{ task.title }}</h1>
            <hr>
            <p class="m-0 font-weight-bold">Description:</p>
            <p>{{ task.description }}</p>
            {% if is_granted('ROLE_ADMIN') %}
                <p class="m-0 font-weight-bold">Assigned to:</p>
                <p>{{ task.getAssignedTo() }}</p>
            {% endif %}
            <p class="m-0 font-weight-bold">Priority:</p>
            <p>{{ task.priority }}</p>
            <p class="m-0 font-weight-bold">Status:</p>
            <p>{{ task.status }}</p>
            <p class="m-0 font-weight-bold">Created at:</p>
            <p>{{ task.getCreatedAt() }}</p>
        </div>
        <div class="card-footer">
            <div class="d-flex justify-content-end">
                {% if is_granted('TASK_EDIT', task) %}
                    <a class="btn btn-warning btn-sm mr-2" href="{{ path('app_task_edit', { id: task.id }) }}">Edit</a>
                {% endif %}
                {% if is_granted('TASK_DELETE', task) %}
                    <form method="POST" action="{{ path('app_task_destroy', { id: task.id }) }}">
                        <input type="hidden" name="_method" value="DELETE" />
                        <input type="hidden" name="_token" value="{{ csrf_token('task_delete_'~task.id) }}" />
                        <button class="btn btn-danger btn-sm" type="submit">Delete</button>
                    </form>
                {% endif %}
            </div>
        </div>
{% endblock %}